﻿using System.Reflection;
using System.Runtime.Serialization;
using System.Linq;

namespace Asn1TypeExplorer
{
    class Program
    {
        static void Main(string[] args)
        {
            ReflectionProj.MyModule.Inner_Msg myData = new ReflectionProj.MyModule.Inner_Msg();
            myData.String = "Hello Attributes";
            myData.Optional_flag = true;

            // Exploring schema information (e.g. field names)
            OSS.Asn1rt.Type.Asn1TypeExplorer exp = new OSS.Asn1rt.Type.Asn1TypeExplorer(myData, true);
            exp.GotoRoot();
            exp.GotoFirstChild();

            do
                System.Console.WriteLine("Name '{0}'", exp.GetNodeTypeName());
            while (exp.GotoNextSibling());
        }
    }
}
